#! /bin/sh

#  Copyright (c) International Business Machines  Corp., 2002
#
#  This program is free software;  you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY;  without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
#  the GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program;  if not, write to the Free Software
#  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

# 12/05/02  Port to bash -Robbie Williamson <robbiew@us.ibm.com>
# 02/05/03  Modified - Manoj Iyer <manjo@mail.utexas.edu> use USCTEST macros
#			fixed bugs.
# 07/27/05  Michael Reed  <mreedltp@vnet.ibm.com>
#		Made changes to account for the replacement of syslogd
#		with syslog-ng on SLES
#
##################################################################
# case 3: Do openlog(), log the messages and see whether			#
# ident string is prepended to the message.			 #
#								 #
# syslog.conf should contain:					 #
# *.crit		/usr/adm/critical			 #
# daemon.info		/usr/spool/adm/syslog			 #
##################################################################

. syslog-lib.sh || exit 1

syslog_case3()
{
	# Create the configuration file specific to this test case.
	case "$CONFIG_FILE" in
	/etc/syslog.conf|/etc/rsyslog.conf)
		echo "$RSYSLOG_CONFIG" > $CONFIG_FILE
		echo "daemon.info	/var/log/messages" >> $CONFIG_FILE
		;;

	/etc/syslog-ng/syslog-ng.conf)
		echo "source src{ internal(); unix-dgram(\"/dev/log\"); udp(ip(\"0.0.0.0\") port(514)); };" > $CONFIG_FILE
		echo " " >> $CONFIG_FILE
		echo "# Added for syslog testcase"  >> $CONFIG_FILE
		echo "filter f_syslog_daemon { level(info) and facility(daemon); }; " >> $CONFIG_FILE
		echo "destination syslog-messages { file(\"/var/log/messages\");};" >> $CONFIG_FILE
		echo "log { source(src); filter(f_syslog_daemon); destination(syslog-messages);};"  >> $CONFIG_FILE
		;;
	esac

	restart_syslog_daemon

	# Grep for the ident prefix: SYSLOG_CASE3 in the log file.
	if [ -e /var/log/messages ]; then
		oldvalue4=`grep -c "SYSLOG_CASE3" /var/log/messages`
	else
		oldvalue4=0
	fi

	if ! syslogtst 3 2>/dev/null; then
		cleanup 1
	fi
	sleep 2

	# check if /var/log/messages exists
	if [ ! -e /var/log/messages ]; then
		tst_resm TBROK "/var/log/messages no such log file"
		cleanup 1
	fi

	newvalue4=`grep -c "SYSLOG_CASE3" /var/log/messages`
	if [ "x$(( $newvalue4 - $oldvalue4 ))" != x1 ]; then
		status_flag=1
	fi
}

tst_resm TINFO "Do openlog(), log the messages and see whether"
tst_resm TINFO "ident string is prepended to the message."

setup
syslog_case3
cleanup ${status_flag:=0}